﻿/**************************************************************************
@ file name TextExtraction.jsx
@ description テキストレイヤーのフォント情報抽出
@ version 2.0
@ author Tsudoi Yoshimoto
@ url http://tsudoi.org/weblog/?p=1210
@ last update date 2013.05.15
**************************************************************************/

function getLayerMetadata(){
        var _xml = "<object>"; 
        if(
            app.documents.length < 1
        ){
            _xml += convertToXML("", "layerTxt");
            _xml += convertToXML("", "codeTxt");
            _xml += convertToXML("", "altTxt");
            _xml += convertToXML("", "fontfamily");
            _xml += convertToXML("", "fontcolor");
            _xml += convertToXML("", "fontsize");
            _xml += convertToXML("", "lineheight");
            _xml += convertToXML("", "bold");
            _xml += convertToXML("", "italic");
            _xml += "</object>";
            return _xml;
        }else{ 
            if(
                !app.activeDocument.activeLayer.isBackgroundLayer
            ){
                var _layer = app.activeDocument.activeLayer;
                
                /*
                for( var prop in _layer.textItem ){
                    try{alert( prop + ' : ' + _layer.textItem[prop] );}catch(e){}
                    }
                    */
                
                try{
                    _xml += convertToXML(_layer.name.toString(), "layerTxt");
                }catch(e){
                    _xml += convertToXML("", "layerTxt");
                }
            
                try{
                    _xml += convertToXML(_layer.textItem.contents, "codeTxt");
                }catch(e){
                    _xml += convertToXML("", "codeTxt");
                }
            
                try{
                    _xml += convertToXML(_layer.textItem.contents, "altTxt");
                }catch(e){
                    _xml += convertToXML("", "altTxt");
                }
                
                try{
                    _xml += convertToXML(_layer.textItem.font, "fontfamily");
                }catch(e){
                    _xml += convertToXML("", "fontfamily");
                }  
                
                var _colorStr = '';
                var _ref = new ActionReference();
                var _desc; //ActionDescriptor
                //_ref.putClass( charIDToTypeID( "Hd  " ) );
                _ref.putEnumerated(charIDToTypeID('Lyr '), charIDToTypeID('Ordn'), charIDToTypeID('Trgt'));
                _desc = executeActionGet(_ref);
                
                /*
                if(_desc.typename == 'ActionDescriptor'){
                    var c = _desc.count;
                    for(var i=0;i<c;i++){ //enumerate descriptor's keys
                        alert( 'Key '+zeroPad( i+1, 2 )+' = '+IDTz(_desc.getKey(i))+' : '+_desc.getType(_desc.getKey(i)) );
                    }
                }
                */
                
                //レイヤー効果
                if( _desc.hasKey( charIDToTypeID('Lefx') ) ) {
                    var _lfxv = getBoolean(_desc, 'lfxv'); //レイヤー効果がアクティブかどうか
                    if( _lfxv ){
                        var _lefxDesc = _desc.getObjectValue( charIDToTypeID('Lefx') );
                        //カラーオーバーレイ
                        if( _lefxDesc.hasKey( charIDToTypeID( 'SoFi' ) ) ){
                            var _soFiDesc = _lefxDesc.getObjectValue( charIDToTypeID( 'SoFi' ) );
                            var _enab = getBoolean(_soFiDesc,'enab');
                            if( _enab ){
                                var _color = getColor(_soFiDesc,'Clr '); //色
                                _colorStr = rgbToHex(_color); //webカラー
                            }
                            else{
                                _colorStr = '#'+_layer.textItem.color.nearestWebColor.hexValue;
                            }
                        }
                        else{
                            _colorStr = '#'+_layer.textItem.color.nearestWebColor.hexValue;
                        }
                    }
                    else{
                        _colorStr = '#'+_layer.textItem.color.nearestWebColor.hexValue;
                    }
                }
                else{
                    try{
                        _colorStr = '#'+_layer.textItem.color.nearestWebColor.hexValue;
                    }
                    catch(e){
                        _colorStr = '#000000';
                    }
                }
                _xml += convertToXML(_colorStr, "fontcolor");
            
                try{
                    _xml += convertToXML(String(_layer.textItem.size), "fontsize");
                }catch(e){
                    _xml += convertToXML("12 px", "fontsize");
                }
                
                try{
                    _xml += convertToXML(String(_layer.textItem.leading), "lineheight");
                }catch(e){
                    _xml += convertToXML("120%", "lineheight");
                }
            
                try{
                    _xml += convertToXML(_layer.textItem.fauxBold, "bold");
                }catch(e){
                    _xml += convertToXML("", "bold");
                }
            
                try{
                    _xml += convertToXML(_layer.textItem.fauxItalic, "italic");
                }catch(e){
                    _xml += convertToXML("", "italic");
                }
            
                _xml += "</object>";
                return _xml;
                
            }else{
                _xml += convertToXML("", "layerTxt");
                _xml += convertToXML("", "codeTxt");
                _xml += convertToXML("", "altTxt");
                _xml += convertToXML("", "fontfamily");
                _xml += convertToXML("", "fontcolor");
                _xml += convertToXML("", "fontsize");
                _xml += convertToXML("", "lineheight");
                _xml += convertToXML("", "bold");
                _xml += convertToXML("", "italic");
                _xml += "</object>";
                return _xml;
            }
        }
}

/*
* description : charID と stringIDを返す
* param _id(number) : id
* return string
*/
function IDTz(_id){
    var _isCharID = false;
    try {
        if( new String( _id ).length == 10 ) {
            _isCharID = true;
            var _charID = '"'+typeIDToCharID( _id )+'"';
            var _stringID = '"'+typeIDToStringID( _id )+'"';
            if( _stringID.length <=2 ) {
                _stringID = '  NA   ';
            }else{
                while( _stringID.length < 25 ){
                _stringID += ' ';
                }
            }
        }else{
            var _charID = ' NA  ';
            var _stringID = '"'+typeIDToStringID( _id )+'"';
            while( _stringID.length < 25 ){
                _stringID += ' ';
            }
        }
    }catch(e){}
    return _charID+' | '+_stringID;
}
function zeroPad(num,pad) {
     var z = Math.pow(10,Number(pad))
     return num <= z ? ((Number( num) + z).toString().substr(1)): num
}

function unloadXMPLibrary(){
	if( ExternalObject.AdobeXMPScript ) {
		try{
			ExternalObject.AdobeXMPScript.unload();
			ExternalObject.AdobeXMPScript = undefined;
		}catch (e){
			alert("Can't unload XMP Script Library");
		}
	}
}

function loadXMPLibrary(){
	if ( !ExternalObject.AdobeXMPScript ){
		try{
			ExternalObject.AdobeXMPScript = new ExternalObject('lib:AdobeXMPScript');
		}catch (e){
			alert("Can't load XMP Script Library");
			return false;
		}
	}
	return true;
}

/*
* description : getBoolean ( log : putBoolean )
* param _desc(ActionDescriptor) : 対象ActionDescriptor
* param _id(string) : charIDToTypeID
* return boolean
*/
function getBoolean(_desc, _id){
    return _desc.getBoolean( charIDToTypeID(_id) );
}

/*
* description : putObject
* param _desc(ActionDescriptor) : 対象ActionDescriptor
* param _id(string) : charIDToTypeID
* return SolidColor
*/
function getColor(_desc, _id){
    var _colorDesc = _desc.getObjectValue(charIDToTypeID(_id));
    var _colour = new SolidColor();
    _colour.rgb.red = _colorDesc.getDouble(charIDToTypeID('Rd  '));
    _colour.rgb.green = _colorDesc.getDouble(charIDToTypeID('Grn '));
    _colour.rgb.blue = _colorDesc.getDouble(charIDToTypeID('Bl  '));
    return _colour;
}

/*
* description : rgbカラーを16進数カラーに変換する
* param _color(SolidColor) : 対象SolidColor
* return string( webカラー )
*/
function rgbToHex(_color){
    var _r = '';
    var _g = '';
    var _b = '';
    if( _color.rgb.red < 16 ){
        _r = '0' +  _color.rgb.red.toString(16);
    }
    else {
		_r = String( _color.rgb.red.toString(16) );
	}

    if( _color.rgb.green < 16 ){
        _g = '0' +  _color.rgb.green.toString(16);
    }
    else {
		_g = String( _color.rgb.green.toString(16) );
	}

    if( _color.rgb.blue < 16 ){
        _b = '0' +  _color.rgb.blue.toString(16);
    }
    else {
		_b = String( _color.rgb.blue.toString(16) );
	}
     return '#' + _r + _g + _b;
}

function convertToXML(property, identifier){
	var type = typeof property;
	var xml = '<property id = "' + identifier + '" >';
	
	switch(type){
		case "number":
			xml += "<number>";
			xml += property.toString();
			xml += "</number>";
			break;
		case "boolean":
			xml += "<" + property.toString() + "/>";
			break;
		case "string":
			xml += "<string>";
			xml += property.toString();
			xml += "</string>";
			break;
		case "object":
			// Object case is currently not supported
			alertDebug("Object case is currently not supported");
			//xml += "<object>";
			//for(var i in property)
			//	xml += convertToXML(property[i], 
			//xml += "</object>";
			break;
		case "undefined":
			xml += "<string>undefined</string>";
			break;
		default:
			alertDebug("Type " + type + " is unknown.");
			return "";
	}
	xml += '</property>';
	return xml;
}

function alertDebug(__str){
    alert(__str);
}